type CamelCase<S extends string> = S extends `${infer P1}_${infer P2}${infer P3}` ? `${P1}${Uppercase<P2>}${CamelCase<P3>}` : S;
type CamelToSnakeCase<S extends string> = S extends `${infer T}${infer U}` ? `${T extends Capitalize<T> ? "_" : ""}${Lowercase<T>}${CamelToSnakeCase<U>}` : S;
export type Camelize<T> = {
    [K in keyof T as CamelCase<string & K>]: T[K] extends Array<infer U> ? U extends {} ? Array<Camelize<U>> : T[K] : T[K] extends {} ? Camelize<T[K]> : T[K];
};
export type Snakeize<T> = {
    [K in keyof T as CamelToSnakeCase<string & K>]: T[K] extends Array<infer U> ? U extends {} ? Array<Snakeize<U>> : T[K] : T[K] extends {} ? Snakeize<T[K]> : T[K];
};
export declare function camelize<T>(obj: T): T extends String ? string : T extends (infer R)[] ? Camelize<R>[] : Camelize<T>;
export declare function snakeize<T>(obj: T): T extends String ? string : T extends (infer R)[] ? Snakeize<R>[] : Snakeize<T>;
export {};
