"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.snakeize = exports.camelize = void 0;
function camelCase(str) {
    return str.replace(/[_.-](\w|$)/g, function (_, x) {
        return x.toUpperCase();
    });
}
function snakeCase(str) {
    return str.replace(/[A-Z]/g, function (str) {
        return `_${str.toLowerCase()}`;
    });
}
function processWalk(obj, fn) {
    const walk = (obj) => {
        if (!obj || typeof obj !== "object")
            return obj;
        if (obj instanceof Date || obj instanceof RegExp)
            return obj;
        if (Array.isArray(obj))
            return obj.map(walk);
        return Object.keys(obj).reduce((res, key) => {
            const camel = fn(key);
            res[camel] = walk(obj[key]);
            return res;
        }, {});
    };
    return walk(obj);
}
function camelize(obj) {
    return typeof obj === "string"
        ? camelCase(obj)
        : processWalk(obj, (key) => camelCase(key));
}
exports.camelize = camelize;
function snakeize(obj) {
    return typeof obj === "string"
        ? camelCase(obj)
        : processWalk(obj, (key) => snakeCase(key));
}
exports.snakeize = snakeize;
//# sourceMappingURL=index.js.map